%define shortVersion %(echo %{version} | cut -d. -f1,2)

%bcond_with bootstrap
%define with_tests 0


Name: cmake
Summary: Cross-platform, open-source make system
Summary(de): Plattformunabhängiges OpenSource make System
Version:	3.12.3
Release:	%mkrel 1
License:	BSD
Group:		Development/Other
Url:		http://www.cmake.org/
Source0:	http://www.cmake.org/files/v%{shortVersion}/%{name}-%{version}.tar.xz
Source1:	cmake.macros
Source3:        cmake.attr
Source4:        cmake.prov
BuildRequires:	perl
BuildRequires:	ncurses-devel
BuildRequires:	libcurl-devel
BuildRequires:	idn-devel
BuildRequires:	zlib-devel
BuildRequires:	xz
BuildRequires:	expat-devel
BuildRequires:	bzip2-devel
BuildRequires:	libarchive-devel

%if ! %with bootstrap
BuildRequires:	qt5widgets-devel
%endif
BuildRequires:	gcc-gfortran

%description
CMake is used to control the software compilation process using
simple platform and compiler independent configuration files.
CMake generates native makefiles and workspaces that can be
used in the compiler environment of your choice. CMake is quite
sophisticated: it is possible to support complex environments
requiring system configuration, pre-processor generation, code
generation, and template instantiation.

%description -l de
CMake wird genutzt um den Prozess der Softwarekompilierung zu
kontrollieren, wobei eine einfache Plattform und vom Kompiler
unabhängige Konfigurationsdateien genutzt werden. CMake generiert
native makefiles und Arbeitsplätze die in der Kompilerumgebung Ihrer
Wahl genutzt werden kann. CMake ist einfach sehr hochentwickelt:
es ist möglich die Konfiguration von komplexen verlangenden Umgebungen
zu unterstützen, die Pre-Prozessor-Generierung, Kodegenerierung und
Vorlageninstanzierung.


%files
%_bindir/cmake
%_bindir/ccmake
%_bindir/ctest
%_bindir/cpack
%_datadir/%{name}
%_sysconfdir/emacs/site-start.d/%{name}.el
%_datadir/emacs/site-lisp/cmake-mode.el
%_sysconfdir/rpm/macros.d/*
%_datadir/aclocal/cmake.m4
%_datadir/bash-completion/completions/*
%{_prefix}/lib/rpm/fileattrs/cmake.attr
%{_prefix}/lib/rpm/cmake.prov
%dir %_libdir/%name

#-----------------------------------------------------------------------------

%if ! %with bootstrap
%package -n %{name}-qtgui
Summary: Qt GUI Dialog for CMake - the Cross-platform, open-source make system
Summary(de): Qt GUI Dialog für CMake - das plattformunabhängige OpenSource make System
Group:      Development/Other
Requires:   %name

%description -n %{name}-qtgui
CMake is used to control the software compilation process using
simple platform and compiler independent configuration files.

This is the Qt GUI.

%description -n %{name}-qtgui -l de
CMake wird genutzt um den Prozess der Softwarekompilierung zu
kontrollieren, wobei eine einfache Plattform und vom Kompiler
unabhängige Konfigurationsdateien genutzt werden.

Dies ist die Qt GUI.


%files -n %{name}-qtgui
%_bindir/cmake-gui
%_datadir/applications/cmake-gui.desktop
%_datadir/mime/packages/cmakecache.xml
%_iconsdir/*/*/*/*.png
%endif

#-----------------------------------------------------------------------------

%prep
%setup -q -n %{name}-%{version}%{?prerel:-%prerel}

# Don't try to automagically find files in /usr/X11R6
# But also don't change a prefix if it is not /usr
perl -pi -e 's@^\s+/usr/X11R6/.*\n@@' Modules/*.cmake


%build
mkdir -p build
cd build
%setup_compile_flags
../configure \
    --parallel="%_smp_mflags" \
    --prefix=%{_prefix} \
    --datadir=/share/%{name} \
    --mandir=/share/man \
    --docdir=/share/doc/%{name} \
%if ! %with bootstrap
    --qt-gui
%endif

%make

%install
rm -rf %buildroot
%makeinstall_std -C build

# cmake mode for emacs
install -m644 Auxiliary/cmake-mode.el -D %buildroot%_datadir/emacs/site-lisp/cmake-mode.el
install -d %buildroot%_sysconfdir/emacs/site-start.d
cat <<EOF >%buildroot%_sysconfdir/emacs/site-start.d/%{name}.el
(setq load-path (cons (expand-file-name "/dir/with/cmake-mode") load-path))
(require 'cmake-mode)
(setq auto-mode-alist
      (append '(("CMakeLists\\\\.txt\\\\'" . cmake-mode)
                ("\\\\.cmake\\\\'" . cmake-mode))
              auto-mode-alist))
EOF

# Create/Own this dir as this is used in cmake dependant rpms but not own by any
mkdir -p %buildroot%_libdir/%name

# RPM macros
install -m644 %SOURCE1 -D %buildroot%_sysconfdir/rpm/macros.d/cmake.macros

# RPM auto provides
install -p -m0644 -D %{SOURCE3} %{buildroot}%{_prefix}/lib/rpm/fileattrs/cmake.attr
install -p -m0755 -D %{SOURCE4} %{buildroot}%{_prefix}/lib/rpm/cmake.prov

# bash-completion    
install -D Auxiliary/bash-completion/%name %buildroot%_datadir/bash-completion/completions/%name     
install -D Auxiliary/bash-completion/cpack %buildroot%_datadir/bash-completion/completions/cpack     
install -D Auxiliary/bash-completion/ctest %buildroot%_datadir/bash-completion/completions/ctest

# There are some stray Copyright.txt files there sometimes.
rm -fr %buildroot/usr/share/doc/cmake


%changelog
* Wed Oct 17 2018 adrianomorselli <adrianomorselli> 3.12.3-1uplos2018
- update
